Program SvcDeb;
// Module:     SvcDeb
// Version:    1.10
// Purpose:    Debug Helper to debug service with td32
//             This module enables one to debug a service in context
//             (as started from the Service Control Manager)
//
// Author:     Peter Sawatzki (ps)
//             Buchenhof 3, 58091 Hagen, Germany
// CompuServe: 100031,3002
// E-Mail:     Peter@Sawatzki.de
// web:        http://www.sawatzki.de
//
// Date:    Author:
// 02/11/97 ps     quick hack written
// 07/07/97 ps     make configurable with DebCfg
//
//  1997 Peter Sawatzki

// Installation instructions
//   1) compile SvcDeb.Dpr using "dcc32 -cc SvcDeb" or use IDE
//   2) copy svcdeb.exe to a directory with <= 15 characters path length (%SystemRoot%\System32
//      is a good place), identify where Turbo Debugger 5.0 (TD32.Exe) is located
//   3) compile DebCfg.exe
//   4) run DebCfg and add the service you want to debug: just specify the exe-file WITHOUT path
//   5) enter location of svcdeb.exe and td32 as appropriate
//
// now if you start your service TD32 is automatically launched with your service
// as a debugee. Set a breakpoint in the routine where you want to stop execution
// and let the thing run so the SCM can continue to initialize the service.
//
Uses
  SysUtils,
  Windows,
  Registry;

Const
  ImageFileExecutionOptions =
    'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Image File Execution Options';

  Function GetTD32 (Value: String): String;
  Begin
    Result:= '';
    Value:= UpperCase(ExtractFileName(Value));
    If Pos('.EXE', Value)=0 Then
      Value:= Value+'.EXE';
    With TRegistry.Create Do
    Try
      RootKey:= HKEY_LOCAL_MACHINE;
      If OpenKey(ImageFileExecutionOptions+'\'+Value, False) Then
        Result:= ReadString('TD32');
    Finally
      Free
    End
  End;

Var
  SI: TStartupInfo;
  PI: TProcessInformation;
  HostAppDir, TD32: String[80];
  Launch, Params: String;
  i: Integer;
Begin
  HostAppDir:= ExtractFilePath(ParamStr(1));
  TD32:= GetTD32(ParamStr(1));
  Params:= ParamStr(2);
  For i:= 3 To ParamCount Do
    Params:= Params+' '+ParamStr(i);
  FillChar(SI, SizeOf(SI), 0);
  FillChar(PI, SizeOf(PI), 0);
  SI.cb:= SizeOf(SI);
  SI.lpDesktop:= PChar('WinSta0\Default');
  If TD32='' Then
    Launch:= Format('%s %s', [ParamStr(1), Params])
  Else
    Launch:= Format('%s -t%s -sd%s %s %s',
                [TD32, HostAppDir, HostAppDir, ParamStr(1), Params]);

  CreateProcess(Nil, PChar(Launch), Nil, Nil, False, CREATE_NEW_CONSOLE, Nil, Nil, SI, PI);
  WaitForSingleObject(PI.HProcess, Infinite);
  CloseHandle(PI.hThread);
  CloseHandle(PI.hProcess);
End.
